var JSDBuf = {};

(function() {

    JSDBuf.init = function (firstURL) {
        var disp = document.getElementById("__disp__");
        disp.innerHTML = '<div id="frontBuf"><iframe src="' + firstURL +
        '"></iframe></div><div id="backBuf"></div>';
    };

    JSDBuf.transition = function (targetURL) {
        var backBuf = document.getElementById("backBuf");
        backBuf.innerHTML = '<iframe></iframe>'
        backBuf.firstChild.onload = backLoaded;
        backBuf.firstChild.src = targetURL;
    };

    function backLoaded() {
        var frontBuf = document.getElementById("frontBuf");
        var animationName = getAnimationName(frontBuf);
        frontBuf.addEventListener("animationend", JSDBuf.transitionEnd, false);
        var animationSec = getAnimationSec();
        frontBuf.style[animationName] = "fadeOut " + animationSec + "s";
    }
    
    function getAnimationSec() {
        if (parent) {
            var animationSec = parent.document.getElementById("animationSec");
            if (animationSec) {
                return animationSec.value;
            }
        }
        return "0.1";
    }

    JSDBuf.transitionEnd = function () {
        var frontBuf = document.getElementById("frontBuf");
        frontBuf.removeChild(frontBuf.firstChild);
        frontBuf.removeEventListener("animationend", JSDBuf.transitionEnd, false);
        var animationName = getAnimationName(frontBuf);
        frontBuf.style[animationName] = '';
        var backBuf = document.getElementById("backBuf");
        frontBuf.id = "backBuf";
        backBuf.id = "frontBuf";
    };
    
    function getAnimationName(element) {
        var animationName = 'animation';
        if ("undefined" != typeof element.style.WebkitAnimation) {
            animationName = 'WebkitAnimation';
        }
        return animationName;
    }

})();

